diff --git a/mcs/class/System.Web/System.Web.UI/Page.cs b/mcs/class/System.Web/System.Web.UI/Page.cs
index ad13eaf..3522767 100644
--- a/mcs/class/System.Web/System.Web.UI/Page.cs
+++ b/mcs/class/System.Web/System.Web.UI/Page.cs
@@ -38,7 +38,6 @@ using System.ComponentModel.Design;
 using System.ComponentModel.Design.Serialization;
 using System.Globalization;
 using System.IO;
-using System.Security.Cryptography;
 using System.Security.Permissions;
 using System.Security.Principal;
 using System.Text;
@@ -2535,74 +2534,6 @@ public partial class Page : TemplateControl, IHttpHandler
 		controlRegisteredForViewStateEncryption = true;
 	}
 
-	static byte [] AES_IV = null;
-	static byte [] TripleDES_IV = null;
-	static object locker = new object ();
-	static bool isEncryptionInitialized = false;
-
-	static void InitializeEncryption () 
-	{
-		if (isEncryptionInitialized)
-			return;
-
-		lock (locker) {
-			if (isEncryptionInitialized)
-				return;
-
-			string iv_string = "0BA48A9E-736D-40f8-954B-B2F62241F282";
-			AES_IV = new byte [16];
-			TripleDES_IV = new byte [8];
-
-			int i;
-			for (i = 0; i < AES_IV.Length; i++) {
-				AES_IV [i] = (byte) iv_string [i];
-			}
-
-			for (i = 0; i < TripleDES_IV.Length; i++) {
-				TripleDES_IV [i] = (byte) iv_string [i];
-			}
-
-			isEncryptionInitialized = true;
-		}
-	}
-
-	internal ICryptoTransform GetCryptoTransform (CryptoStreamMode cryptoStreamMode) 
-	{
-		ICryptoTransform transform = null;
-		MachineKeySection config = (MachineKeySection) WebConfigurationManager.GetSection (machineKeyConfigPath);
-		byte [] vk = MachineKeySectionUtils.ValidationKeyBytes (config);
-
-		switch (config.Validation) {
-			case MachineKeyValidation.SHA1:
-				transform = SHA1.Create ();
-				break;
-
-			case MachineKeyValidation.MD5:
-				transform = MD5.Create ();
-				break;
-
-			case MachineKeyValidation.AES:
-				InitializeEncryption ();
-				if (cryptoStreamMode == CryptoStreamMode.Read){
-					transform = Rijndael.Create().CreateDecryptor(vk, AES_IV);
-				} else {
-					transform = Rijndael.Create().CreateEncryptor(vk, AES_IV);
-				}
-				break;
-
-			case MachineKeyValidation.TripleDES:
-				InitializeEncryption ();
-				if (cryptoStreamMode == CryptoStreamMode.Read){
-					transform = TripleDES.Create().CreateDecryptor(vk, TripleDES_IV);
-				} else {
-					transform = TripleDES.Create().CreateEncryptor(vk, TripleDES_IV);
-				}
-				break;
-		}
-
-		return transform;
-	}
-
 	internal bool NeedViewStateEncryption {
 		get {
 			return (ViewStateEncryptionMode == ViewStateEncryptionMode.Always ||
diff --git a/mcs/class/System.Web/System.Web.dll.sources b/mcs/class/System.Web/System.Web.dll.sources
index 6e4e12e..16087d1 100644
--- a/mcs/class/System.Web/System.Web.dll.sources
+++ b/mcs/class/System.Web/System.Web.dll.sources
@@ -7,6 +7,7 @@ Assembly/AssemblyInfo.cs
 ../Managed.Windows.Forms/System.Resources/ResXFileRef.cs
 ../Managed.Windows.Forms/System.Resources/ResXDataNode.cs
 ../Managed.Windows.Forms/System.Resources/ResXNullRef.cs
+../Mono.Security/Mono.Security.Cryptography/TlsHMAC.cs
 System.Web.Configuration_2.0/CapabilitiesBuild.cs
 System.Web.Configuration_2.0/CapabilitiesResult.cs
 System.Web.Configuration_2.0/ICapabilitiesProcess.cs
diff --git a/mcs/class/System.Web/System.Web_test.dll.sources b/mcs/class/System.Web/System.Web_test.dll.sources
index b1f8fe4..e40268f 100644
--- a/mcs/class/System.Web/System.Web_test.dll.sources
+++ b/mcs/class/System.Web/System.Web_test.dll.sources
@@ -85,6 +85,8 @@ System.Web.Configuration/CustomErrorCollectionTest.cs
 System.Web.Configuration/DeploymentSectionTest.cs
 System.Web.Configuration/GlobalizationSectionTest.cs
 System.Web.Configuration/HostingEnvironmentSectionTest.cs
+System.Web.Configuration/MachineKeySectionTest.cs
+System.Web.Configuration/MachineKeySectionUtilsTest.cs
 System.Web.Configuration/MachineKeyValidationConverterTest.cs
 System.Web.Configuration/NullableStringValidatorTest.cs
 System.Web.Configuration/ProfilePropertySettingsTest.cs
diff --git a/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionTest.cs b/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionTest.cs
new file mode 100644
index 0000000..ac5fce8
--- /dev/null
+++ b/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionTest.cs
@@ -0,0 +1,158 @@
+//
+// Unit tests for MachineKeySection
+//
+// Author:
+//	Sebastien Pouliot  <sebastien@ximian.com>
+//
+// Copyright (C) 2010 Novell, Inc (http://www.novell.com)
+//
+// Permission is hereby granted, free of charge, to any person obtaining
+// a copy of this software and associated documentation files (the
+// "Software"), to deal in the Software without restriction, including
+// without limitation the rights to use, copy, modify, merge, publish,
+// distribute, sublicense, and/or sell copies of the Software, and to
+// permit persons to whom the Software is furnished to do so, subject to
+// the following conditions:
+// 
+// The above copyright notice and this permission notice shall be
+// included in all copies or substantial portions of the Software.
+// 
+// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+//
+#if NET_2_0
+using System;
+using System.Configuration;
+using System.Web.Configuration;
+using NUnit.Framework;
+
+namespace MonoTests.System.Web.Configuration {
+
+	[TestFixture]
+	public class MachineKeySectionTest {
+
+		[Test]
+		public void DefaultValues ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+#if NET_4_0
+			Assert.AreEqual (MachineKeyCompatibilityMode.Framework20SP1, section.CompatibilityMode, "CompatibilityMode");
+#endif
+			Assert.AreEqual ("Auto", section.Decryption, "Decryption");
+			Assert.AreEqual ("AutoGenerate,IsolateApps", section.DecryptionKey, "DecryptionKey");
+#if NET_4_0
+			Assert.AreEqual (MachineKeyValidation.HMACSHA256, section.Validation, "Validation");
+			Assert.AreEqual ("HMACSHA256", section.ValidationAlgorithm, "ValidationAlgorithm");
+#else
+			Assert.AreEqual (MachineKeyValidation.SHA1, section.Validation, "Validation");
+#endif
+			Assert.AreEqual ("AutoGenerate,IsolateApps", section.ValidationKey, "ValidationKey");
+		}
+
+		[Test]
+#if NET_4_0
+		[ExpectedException (typeof (NullReferenceException))]
+#else
+		[ExpectedException (typeof (ConfigurationErrorsException))]
+#endif
+		public void Decryption_Null ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Decryption = null;
+		}
+
+		[Test]
+		[ExpectedException (typeof (ConfigurationErrorsException))]
+		public void Decryption_Empty ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Decryption = String.Empty;
+		}
+#if NET_4_0
+		[Test]
+		public void Decryption_RC2 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			Assert.AreEqual ("Auto", section.Decryption, "before");
+
+			section.Decryption = "alg:RC2";
+			Assert.AreEqual ("alg:RC2", section.Decryption, "after");
+		}
+
+		[Test]
+		public void Decryption_InvalidName ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			Assert.AreEqual ("Auto", section.Decryption, "before");
+
+			section.Decryption = "alg:UnexistingType";
+			// looks like the problem is found (much) later
+			Assert.AreEqual ("alg:UnexistingType", section.Decryption, "Decryption");
+		}
+
+		[Test]
+		public void ValidationAlgorithm_Null ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.ValidationAlgorithm = null;
+			Assert.AreEqual ("HMACSHA256", section.ValidationAlgorithm, "ValidationAlgorithm");
+		}
+
+		[Test]
+		[ExpectedException (typeof (ArgumentException))]
+		public void ValidationAlgorithm_Empty ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.ValidationAlgorithm = String.Empty;
+		}
+
+		[Test]
+		[ExpectedException (typeof (ArgumentException))]
+		public void Validation_Custom ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.Custom;
+			// cannot be set directly
+		}
+
+		[Test]
+		[ExpectedException (typeof (ArgumentException))]
+		public void ValidationAlgorithm ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.ValidationAlgorithm = "HMACRIPEMD160";
+			// syntax is: alg:something-deriving-from-KeyedHashAlgorithm
+		}
+
+		[Test]
+		public void ValidationAlgorithm_RIPEMD160 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			Assert.AreEqual (MachineKeyValidation.HMACSHA256, section.Validation, "before");
+
+			section.ValidationAlgorithm = "alg:HMACRIPEMD160";
+			Assert.AreEqual (MachineKeyValidation.Custom, section.Validation, "after");
+			Assert.AreEqual ("alg:HMACRIPEMD160", section.ValidationAlgorithm, "ValidationAlgorithm");
+		}
+
+		[Test]
+		public void ValidationAlgorithm_InvalidName ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			Assert.AreEqual (MachineKeyValidation.HMACSHA256, section.Validation, "before");
+
+			section.ValidationAlgorithm = "alg:UnexistingType";
+			// looks like the problem is found (much) later
+			Assert.AreEqual (MachineKeyValidation.Custom, section.Validation, "after");
+			Assert.AreEqual ("alg:UnexistingType", section.ValidationAlgorithm, "ValidationAlgorithm");
+		}
+#endif
+	}
+}
+
+#endif
diff --git a/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionUtilsTest.cs b/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionUtilsTest.cs
new file mode 100644
index 0000000..3564cc0
--- /dev/null
+++ b/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeySectionUtilsTest.cs
@@ -0,0 +1,310 @@
+//
+// Unit tests for MachineKeySectionUtils (internals)
+//
+// Author:
+//	Sebastien Pouliot  <sebastien@ximian.com>
+//
+// Copyright (C) 2010 Novell, Inc (http://www.novell.com)
+//
+// Permission is hereby granted, free of charge, to any person obtaining
+// a copy of this software and associated documentation files (the
+// "Software"), to deal in the Software without restriction, including
+// without limitation the rights to use, copy, modify, merge, publish,
+// distribute, sublicense, and/or sell copies of the Software, and to
+// permit persons to whom the Software is furnished to do so, subject to
+// the following conditions:
+// 
+// The above copyright notice and this permission notice shall be
+// included in all copies or substantial portions of the Software.
+// 
+// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+//
+#if NET_2_0
+using System;
+using System.IO;
+using System.Web.Configuration;
+using NUnit.Framework;
+
+namespace MonoTests.System.Web.Configuration {
+
+	[TestFixture]
+	public class MachineKeySectionUtilsTest {
+
+		public void Encrypt_RoundTrip (MachineKeySection section)
+		{
+			byte [] data = new byte [14];
+			byte [] encdata = MachineKeySectionUtils.Encrypt (section, data);
+			byte [] decdata = MachineKeySectionUtils.Decrypt (section, encdata);
+			Assert.AreEqual (data, decdata, "roundtrip");
+
+			// changing length (missing first byte)
+			byte [] cut = new byte [encdata.Length - 1];
+			Array.Copy (encdata, 1, cut, 0, cut.Length);
+			Assert.IsNull (MachineKeySectionUtils.Decrypt (section, cut), "bad length");
+
+			// changing last byte (padding)
+			byte be = encdata [encdata.Length - 1];
+			encdata [encdata.Length - 1] ^= (byte) (be + 1);
+			Assert.IsNull (MachineKeySectionUtils.Decrypt (section, encdata), "bad padding");
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_Default ()
+		{
+			Encrypt_RoundTrip (new MachineKeySection ());
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_AES ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.AES;
+			Encrypt_RoundTrip (section);
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_TripleDES ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.TripleDES;
+			Encrypt_RoundTrip (section);
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_MD5 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.MD5;
+			Encrypt_RoundTrip (section);
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_SHA1 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.SHA1;
+			Encrypt_RoundTrip (section);
+		}
+#if NET_4_0
+		[Test]
+		public void Encrypt_RoundTrip_HMACSHA256 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA256;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_HMACSHA384 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA384;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_HMACSHA512 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA512;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void Encrypt_RoundTrip_Custom_RIPEMD160 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.ValidationAlgorithm = "alg:HMACRIPEMD160";
+			EncryptSign_RoundTrip (section);
+		}
+#endif
+		public void EncryptSign_RoundTrip (MachineKeySection section)
+		{
+			byte [] data = new byte [14];
+			byte [] block = MachineKeySectionUtils.EncryptSign (section, data);
+			byte [] decdata = MachineKeySectionUtils.VerifyDecrypt (section, block);
+			Assert.AreEqual (data, decdata, "roundtrip");
+
+			// changing a byte of the data
+			byte b0 = block [0];
+			block [0] ^= b0;
+			Assert.IsNull (MachineKeySectionUtils.VerifyDecrypt (section, block), "bad data");
+			block [0] = b0;
+
+			// changing a byte of the signature
+			byte be = block [block.Length - 1];
+			block [block.Length - 1] ^= (byte) (be + 1);
+			Assert.IsNull (MachineKeySectionUtils.VerifyDecrypt (section, block), "bad signature");
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_Default ()
+		{
+			EncryptSign_RoundTrip (new MachineKeySection ());
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_AES ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.AES;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_TripleDES ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.TripleDES;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_MD5 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.MD5;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_SHA1 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.SHA1;
+			EncryptSign_RoundTrip (section);
+		}
+#if NET_4_0
+		[Test]
+		public void EncryptSign_RoundTrip_HMACSHA256 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA256;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_HMACSHA384 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA384;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_HMACSHA512 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA512;
+			EncryptSign_RoundTrip (section);
+		}
+
+		[Test]
+		public void EncryptSign_RoundTrip_Custom_RIPEMD160 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.ValidationAlgorithm = "alg:HMACRIPEMD160";
+			EncryptSign_RoundTrip (section);
+		}
+#endif
+		public void Validation_RoundTrip (MachineKeySection section)
+		{
+			byte [] data = new byte [] { 0x12, 0x34, 0x56, 0x78, 0x9a, 0xbc, 0xde, 0xf0 };
+			byte [] block = MachineKeySectionUtils.Sign (section, data);
+			Assert.AreEqual (data, MachineKeySectionUtils.Verify (section, block), "OK");
+
+			// changing last byte
+			for (int i = 0; i < data.Length; i++) {
+				byte b = block [i];
+				block [i] ^= 0xFF;
+				Assert.IsNull (MachineKeySectionUtils.Verify (section, block), "bad-" + i.ToString ());
+				block [i] = b;
+			}
+		}
+
+		[Test]
+		public void Validation_RoundTrip_Default ()
+		{
+			Validation_RoundTrip (new MachineKeySection ());
+		}
+
+		[Test]
+		public void Validation_RoundTrip_AES ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.AES;
+			Validation_RoundTrip (section);
+		}
+
+		[Test]
+		public void Validation_RoundTrip_TripleDES ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.TripleDES;
+			Validation_RoundTrip (section);
+		}
+
+		[Test]
+		public void Validation_RoundTrip_MD5 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.MD5;
+			Validation_RoundTrip (section);
+		}
+
+		[Test]
+		public void Validation_RoundTrip_SHA1 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.SHA1;
+			Validation_RoundTrip (section);
+		}
+
+#if NET_4_0
+		[Test]
+		public void Validation_RoundTrip_HMACSHA256 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA256;
+			Validation_RoundTrip (section);
+		}
+
+		[Test]
+		public void Validation_RoundTrip_HMACSHA384 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA384;
+			Validation_RoundTrip (section);
+		}
+
+		[Test]
+		public void Validation_RoundTrip_HMACSHA512 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.Validation = MachineKeyValidation.HMACSHA512;
+			Validation_RoundTrip (section);
+		}
+
+		[Test]
+		public void Validation_RoundTrip_Custom_RIPEMD160 ()
+		{
+			MachineKeySection section = new MachineKeySection ();
+			section.ValidationAlgorithm = "alg:HMACRIPEMD160";
+			Validation_RoundTrip (section);
+		}
+#endif
+		[Test]
+		public void GetHexString ()
+		{
+			Assert.AreEqual ("DEADC0DE", MachineKeySectionUtils.GetHexString (new byte [] { 0xde, 0xad, 0xc0, 0xde }), "deadcode");
+		}
+	}
+}
+
+#endif
diff --git a/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeyValidationConverterTest.cs b/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeyValidationConverterTest.cs
index 0ed9243..3df6feb 100644
--- a/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeyValidationConverterTest.cs
+++ b/mcs/class/System.Web/Test/System.Web.Configuration/MachineKeyValidationConverterTest.cs
@@ -2,10 +2,11 @@
 // System.Web.Configuration.MachineKeyValidationConverterTest.cs - Unit tests
 // for System.Web.Configuration.MachineKeyValidationConverter.
 //
-// Author:
+// Authors:
 //	Chris Toshok  <toshok@ximian.com>
+//	Sebastien Pouliot  <sebastien@ximian.com>
 //
-// Copyright (C) 2005 Novell, Inc (http://www.novell.com)
+// Copyright (C) 2005, 2010 Novell, Inc (http://www.novell.com)
 //
 // Permission is hereby granted, free of charge, to any person obtaining
 // a copy of this software and associated documentation files (the
@@ -35,8 +36,7 @@ using NUnit.Framework;
 
 namespace MonoTests.System.Web.Configuration {
 	[TestFixture]
-	public class MachineKeyValidationConverterTest
-	{
+	public class MachineKeyValidationConverterTest {
 		[Test]
 		public void CanConvertFrom ()
 		{
@@ -66,10 +66,46 @@ namespace MonoTests.System.Web.Configuration {
 			object o;
 
 			o = cv.ConvertFrom (null, null, "MD5");
-			Assert.AreEqual (typeof (MachineKeyValidation), o.GetType(), "A1");
-			Assert.AreEqual ("MD5", o.ToString(), "A2");
+			Assert.AreEqual (typeof (MachineKeyValidation), o.GetType (), "typeof");
+			Assert.AreEqual ("MD5", o.ToString (), "MD5");
+
+			o = cv.ConvertFrom (null, null, "SHA1");
+			Assert.AreEqual ("SHA1", o.ToString (), "SHA1");
+
+			// 3DES in, TripleDES out
+			o = cv.ConvertFrom (null, null, "3DES");
+			Assert.AreEqual ("TripleDES", o.ToString (), "3DES");
+
 			o = cv.ConvertFrom (null, null, "AES");
-			Assert.AreEqual ("AES", o.ToString(), "A3");
+			Assert.AreEqual ("AES", o.ToString (), "AES");
+#if NET_4_0
+			o = cv.ConvertFrom (null, null, "HMACSHA256");
+			Assert.AreEqual ("HMACSHA256", o.ToString (), "HMACSHA256");
+
+			o = cv.ConvertFrom (null, null, "HMACSHA384");
+			Assert.AreEqual ("HMACSHA384", o.ToString (), "HMACSHA384");
+
+			o = cv.ConvertFrom (null, null, "HMACSHA512");
+			Assert.AreEqual ("HMACSHA512", o.ToString (), "HMACSHA512");
+#endif
+		}
+
+#if NET_4_0
+		[Test]
+		[ExpectedException (typeof (ArgumentException))]
+		public void ConvertFrom_Custom ()
+		{
+			MachineKeyValidationConverter cv = new MachineKeyValidationConverter ();
+			cv.ConvertFrom (null, null, "Custom");
+		}
+#endif
+
+		[Test]
+		[ExpectedException (typeof (ArgumentException))]
+		public void ConvertFrom_CaseSensitive ()
+		{
+			MachineKeyValidationConverter cv = new MachineKeyValidationConverter ();
+			cv.ConvertFrom (null, null, "sha1");
 		}
 
 		[Test]
@@ -91,10 +127,29 @@ namespace MonoTests.System.Web.Configuration {
 			Assert.AreEqual ("MD5", cv.ConvertTo (null, null, MachineKeyValidation.MD5, typeof (string)), "A1");
 			Assert.AreEqual ("SHA1", cv.ConvertTo (null, null, MachineKeyValidation.SHA1, typeof (string)), "A2");
 			Assert.AreEqual ("3DES", cv.ConvertTo (null, null, MachineKeyValidation.TripleDES, typeof (string)), "A3");
+#if NET_4_0
+			Assert.AreEqual ("HMACSHA256", cv.ConvertTo (null, null, MachineKeyValidation.HMACSHA256, typeof (string)), "HMACSHA256");
+			Assert.AreEqual ("HMACSHA384", cv.ConvertTo (null, null, MachineKeyValidation.HMACSHA384, typeof (string)), "HMACSHA384");
+			Assert.AreEqual ("HMACSHA512", cv.ConvertTo (null, null, MachineKeyValidation.HMACSHA512, typeof (string)), "HMACSHA512");
+#endif
+		}
+
+#if NET_4_0
+		[Test]
+		[ExpectedException (typeof (ArgumentException))]
+		public void ConvertTo_Custom ()
+		{
+			MachineKeyValidationConverter cv = new MachineKeyValidationConverter ();
+			cv.ConvertTo (null, null, MachineKeyValidation.Custom, typeof (string));
 		}
+#endif
 
 		[Test]
+#if NET_4_0
+		[ExpectedException (typeof (ArgumentException))]
+#else
 		[ExpectedException (typeof (NullReferenceException))]
+#endif
 		public void ConvertTo_NullError ()
 		{
 			MachineKeyValidationConverter cv = new MachineKeyValidationConverter ();
@@ -103,7 +158,11 @@ namespace MonoTests.System.Web.Configuration {
 		}
 
 		[Test]
+#if NET_4_0
+		[ExpectedException (typeof (ArgumentException))]
+#else
 		[ExpectedException (typeof (FormatException))]
+#endif
 		public void ConvertTo_TypeError1 ()
 		{
 			MachineKeyValidationConverter cv = new MachineKeyValidationConverter ();
@@ -120,6 +179,17 @@ namespace MonoTests.System.Web.Configuration {
 			Assert.AreEqual ("MD5", cv.ConvertTo (null, null, MachineKeyValidation.MD5, null), "A2");
 		}
 
+		[Test]
+#if NET_4_0
+		[ExpectedException (typeof (ArgumentException))]
+#else
+		[ExpectedException (typeof (FormatException))]
+#endif
+		public void ConvertTo_TypeError3 ()
+		{
+			MachineKeyValidationConverter cv = new MachineKeyValidationConverter ();
+			cv.ConvertTo (null, null, (MachineKeyValidation)Int32.MinValue, typeof (string));
+		}
 	}
 }
 
diff --git a/mcs/class/System.Web/Test/System.Web.Security/FormsAuthenticationTest.cs b/mcs/class/System.Web/Test/System.Web.Security/FormsAuthenticationTest.cs
index b31d721..dbad10e 100644
--- a/mcs/class/System.Web/Test/System.Web.Security/FormsAuthenticationTest.cs
+++ b/mcs/class/System.Web/Test/System.Web.Security/FormsAuthenticationTest.cs
@@ -129,6 +129,16 @@ namespace MonoTests.System.Web.Security
 		{
 			FormsAuthentication.RedirectToLoginPage (String.Empty);
 		}
+
+		[Test]
+		[Category ("NotWorking")] // works on .net
+		public void Authenticate ()
+		{
+			Assert.IsFalse (FormsAuthentication.Authenticate (null, "password"), "null,string");
+			Assert.IsFalse (FormsAuthentication.Authenticate ("user", null), "string,null");
+			// not throwing
+			Assert.IsFalse (FormsAuthentication.Authenticate ("user", "password"), "string,string");
+		}
 #endif
 
 		[TestFixtureTearDown]
diff --git a/mcs/class/System.Web/Test/System.Web.Security/RolePrincipalTest.cs b/mcs/class/System.Web/Test/System.Web.Security/RolePrincipalTest.cs
index 0c6e069..67de9b9 100644
--- a/mcs/class/System.Web/Test/System.Web.Security/RolePrincipalTest.cs
+++ b/mcs/class/System.Web/Test/System.Web.Security/RolePrincipalTest.cs
@@ -1,6 +1,6 @@
 //
-// MembershipUserCollectionTest.cs
-//	- Unit tests for System.Web.Security.MembershipUserCollection
+// RolePrincipalTest.cs
+//	- Unit tests for System.Web.Security.RolePrincipal
 //
 // Author:
 //	Sebastien Pouliot  <sebastien@ximian.com>
